<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 05/23/2004 *
 * ================                             Last change: 06/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-birthday.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Sends out happy-birthday mails                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Versendet Geburtstagsmails an die Mitglieder     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.3.9";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.1", "0.2", "0.2.1", "0.2.2", "0.2.3", "0.2.4", "0.2.5", "0.2.6", "0.2.7", "0.2.8", "0.2.9", "0.3.0", "0.3.1", "0.3.2", "0.3.3", "0.3.4", "0.3.5", "0.3.6", "0.3.7", "0.3.8", "0.3.9");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installtion is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD birthday_sent VARCHAR(10) NOT NULL DEFAULT '0'";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data DROP birthday_sent";
	$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config DROP birthday_points";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_user_birthday";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE what='config_birthday' LIMIT 1";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.1": // SQL queries for v0.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Wenn t&auml;glicher Reset war, wird eine ben&ouml;tigte Include-Datei nicht mehr von daily-reset.php eingebunden, sondern von der Erweiterungsdatei selber.";
		break;

	case "0.2": // SQL queries for v0.2
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD birthday_points BIGINT(20) UNSIGNED NOT NULL DEFAULT '0'";
		$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_user_birthday";
		$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_user_birthday (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
userid BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
points BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
chk_value VARCHAR(255) NOT NULL DEFAULT '',
KEY(userid),
PRIMARY KEY(id)
) Type=MyISAM";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('setup', 'config_birthday', 'Geburtstagsmails', 'Stellen Sie hier ein, ob die Mitglieder {!POINTS!} (nicht automatisch) gutgeschrieben kommen sollen oder nicht.', 9)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Es kann nun eine Gutschrift an die Geburtstagmail angeh&auml;ngt werden. Diese wird erst beim Klick auf einen Best&auml;tigungslink gutgeschrieben.";
		break;

	case "0.2.1": // SQL queries for v0.2.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Abstand zwischen ausgesendeter Geburtstagsmails auf 364 Tage erh&ouml;ht.";
		break;

	case "0.2.4": // SQL queries for v0.2.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Laden der birthday_mails.php &quot;intelligenter&quot; per Datenfeld und Lade-Schleife in load_extensions.php realisiert.";
		break;

	case "0.2.5": // SQL queries for v0.2.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.2.6": // SQL queries for v0.2.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Problem mit Speicherung der Einstellungen beseitigt.";
		break;

	case "0.2.7": // SQL queries for v0.2.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Sicherheitsupdate am Script <U>birtday_confirm.php</U> durchgef&uuml;hrt.";
		break;

	case "0.2.8": // SQL queries for v0.2.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Vergessenes _OB_CACHING gesetzt.";
		break;

	case "0.2.9": // SQL queries for v0.2.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Seit <A href=\"#\">Patch 340</A> &uuml;berfl&uuml;ssige HTML-Tags entfernt.";
		break;

	case "0.3.0": // SQL queries for v0.3.0
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Ausgabe des generierten HTML-Codes nach <U>inc/footer.php</U> verlagert.";
		break;

	case "0.3.1": // SQL queries for v0.3.1
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Wort <STRONG>Punkte</STRONG> dynamisiert.";
		break;

	case "0.3.2": // SQL queries for v0.3.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Sicherheitsupdate: SQL-Anweisungen gesch&uuml;tzt.";
		break;

	case "0.3.3": // SQL queries for v0.3.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Bitte verschieben Sie die birthday-Templates (Ordner: ".PATH."/templates/".GET_LANGUAGE()."/html/) in den neuen Order birthday!";
		break;

	case "0.3.4": // SQL queries for v0.3.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Abspeichern von Einstellungen repariert.";
		break;

	case "0.3.5": // SQL queries for v0.3.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Vorbereitung auf die neue Mediendaten v0.0.4.";
		break;

	case "0.3.6": // SQL queries for v0.3.6
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD birthday_mode ENUM('DIRECT', 'REF') NOT NULL DEFAULT 'DIRECT'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD birthday_active ENUM('Y', 'N') NOT NULL DEFAULT 'N'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Verg&uuml;tungsmodus des Geburtstagsbonus einstellbar.";
		break;

	case "0.3.7": // SQL queries for v0.3.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Im Script <STRONG>inc/birthday_mails.php</STRONG> hat sich ein Zeichen mit dem Code 160 eingeschlichen, welches einen <STRONG>Parser Error</STRONG> verursachte, aber wie eine gew&ouml;hnliche Leerstelle aussah.";
		break;

	case "0.3.8": // SQL queries for v0.3.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Hash-Erstellung von <STRONG>md5()</STRONG> auf bessere Funktion <STRONG>generateHash()</STRONG> umgestellt.";
		break;

	case "0.3.9": // SQL queries for v0.3.8
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_user_data` CHANGE `birth_day` `birth_day` SMALLINT(2) UNSIGNED ZEROFILL NOT NULL DEFAULT '01',
CHANGE `birth_month` `birth_month` SMALLINT(2) UNSIGNED ZEROFILL NOT NULL DEFAULT '01',
CHANGE `birth_year` `birth_year` SMALLINT(4) UNSIGNED ZEROFILL NOT NULL DEFAULT '1970'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Datenbankspalten umgestellt auf SMALLINT() UNSIGNED ZEROFILL.";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	$dummy = LOAD_CONFIG();

	// Copy config to main array
	$_CONFIG = merge_array($_CONFIG, $dummy);

	// Save some RAM...
	unset($dummy);

	if ((isBooleanConstantAndTrue('__DAILY_RESET')) && ($_CONFIG['birthday_points'] > 0)) {
		// Daily reset was run and we shall pay points so we start checking for members who
		// has a birthday for today
		$INC_POOL[] = sprintf("%sinc/mails/birthday_mails.php", PATH);
	}
	break;
}

// Language file prefix
$EXT_LANG_PREFIX = "birthday";

// Extension is always active?
$EXT_ALWAYS_ACTIVE = "N";

//
?>
