<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/19/2003 *
 * ===============                              Last change: 11/19/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-bonus.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Bonus pages for some extra points                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bonusseiten fuer ein paar Extrapunkte            *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
 elseif (!IS_MEMBER())
{
	LOAD_URL("modules.php[5~?module=index");
}
 elseif ((!EXT_IS_ACTIVE("bonus")) && (!IS_ADMIN()))
{
	ADD_FATAL(EXTENSION_PROBLEM_EXT_INACTIVE, "bonus");
	return;
}

// Add description as navigation point
ADD_DESCR("member", basename(__FILE__));
OUTPUT_HTML("</FONT><br />");

if (GET_EXT_VERSION("bonus") >= "0.6.9")
{
	// Add more bonus points here
	$USE = "(0";
	if ($_CONFIG['bonus_click_yn'] == "Y") $USE .= " + turbo_bonus";
	if ($_CONFIG['bonus_login_yn'] == "Y") $USE .= " + login_bonus";
	if ($_CONFIG['bonus_order_yn'] == "Y") $USE .= " + bonus_order";
	if ($_CONFIG['bonus_stats_yn'] == "Y") $USE .= " + bonus_stats";
	if ($_CONFIG['bonus_ref_yn']   == "Y") $USE .= " + bonus_ref";
	$USE .= ")";
}
 else
{
	// Old version ???
	$USE = "turbo_bonus";
}

// Autopurge installed?
$LAST = "%s"; $ONLINE = "";
if (EXT_IS_ACTIVE("autopurge"))
{
	// Use last online timestamp to keep inactive members away from here
	$LAST   = " AND last_online >= %s";
	$ONLINE = bigintval(time() - $_CONFIG['ap_in_since']);
}

// Let's check if there are some points left we can "pay"...
$result = SQL_QUERY_ESC("SELECT userid, ".$USE." AS active_bonus, last_online FROM "._MYSQL_PREFIX."_user_data
WHERE ".$USE." > 0 AND status='CONFIRMED'".$LAST."
ORDER BY active_bonus DESC, last_online DESC, userid LIMIT %s",
 array($ONLINE, $_CONFIG['bonus_ranks']), __FILE__, __LINE__);

// Reset temporary variable and check for users
$OUT = "";
if (SQL_NUMROWS($result) > 0)
{
	// Load our winners...
	$SW = 2; $cnt = 1;
	while(list($uid, $turbo, $last) = SQL_FETCHROW($result))
	{
		// Prepare data for the template
		$content = array(
			'sw'     => $SW,
			'cnt'    => $cnt,
			'uid'    => bigintval($uid),
			'points' => TRANSLATE_COMMA($turbo),
			'last'   => MAKE_DATETIME($last, "2"),
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE("member_bonus_row", true, $content);

		// Count one up and switch colors
		$cnt++;$SW = 3 - $SW;
	}
}
 else
{
	// No one is interested in our "active rallye" ! :-(
	$OUT = LOAD_TEMPLATE("member_bonus_404", true);
}

// Free memory
SQL_FREERESULT($result);

// Remeber row(s) for the template
define('__BONUS_ROWS', $OUT);

// Load final template
LOAD_TEMPLATE("member_bonus");

//
?>
